#include "doomdef.h"
#include "d_event.h"

#include "p_maputl.h"

#include "doomstat.h"

#include "r_main.h"

#include "math.h"

#ifndef CHASE_H
#include "d_chase.h"
#endif

void
P_CamThink(player_t* player)
{
    mobj_t*			camloc;
    
    if (CamTypeSetVar == 1 && ccmode != 2 && oneticb)
    {
    ccmode = 2;
    percentideal = 100;
	chasecamon = true;
    }
    if (CamTypeSetVar == 0 && ccmode != 0 && oneticb)
    {
    ccmode = 0;
    percentideal = 0;
    chasecamon = false;
    }
    
    if (ccmode == 1)
    	percentideal += 4;
    if (ccmode == 1 && (percentideal > 99 || oneticb))
		{    	
    	percentideal = 100;
    	ccmode = 2;
    	CamTypeSetVar = 1;
    	}
    if (ccmode == 3)
    	percentideal -= 4;
    if (ccmode == 3 && (percentideal < 1 || oneticb))
    	{
    	percentideal = 0;
    	ccmode = 0;
    	chasecamon = false;
    	CamTypeSetVar = 0;
    	}    
    if (oneticb)
    	oneticb = 0;
    if (ccmode)
    {
    if(!(player->real->flags&MF_NOSECTOR))
            player->real->flags |= MF_NOSECTOR;
    if(!(player->real->flags&MF_NOBLOCKMAP))
            player->real->flags |= MF_NOBLOCKMAP;
        
    camangle = player->mo->angle;
    // CamAngle var stuff
    
    if (CamAngleSetVar == 0)
    	camangle += ANG180;	
    
    if (CamAngleSetVar == 1)
    	camangle = ANG45 / 3 + ANG180 + player->mo->angle;	
    if (CamAngleSetVar == 2)
    	camangle = ANG45 * 2 / 3 + ANG180+ player->mo->angle;
    if (CamAngleSetVar == 3)
    	camangle = ANG45 + ANG180 + player->mo->angle;
    if (CamAngleSetVar == 4)
    	camangle = ANG90 + ANG180 + player->mo->angle;
    if (CamAngleSetVar == 5)
    	camangle = ANG90 + ANG45 + ANG180+ player->mo->angle;	
    if (CamAngleSetVar == 6)
    	camangle = player->mo->angle;
    if (CamAngleSetVar == 7)
    	camangle = ANG45+ player->mo->angle;	
    if (CamAngleSetVar == 8)
    	camangle = ANG90+ player->mo->angle;
    if (CamAngleSetVar == 9)
    	camangle = ANG90 + ANG45 + player->mo->angle;
    if (CamAngleSetVar == 10)
    	camangle = (ANG180 - ANG45 * 2 / 3) + player->mo->angle;
    if (CamAngleSetVar == 11)
    	camangle = (ANG180 - ANG45 / 3) + player->mo->angle;
    
    if (camangle > 2 * ANG180)
    	camangle -= (2 * ANG180);
    if (camangle < 0)
    	camangle += (2 * ANG180);
    
	heightangle = 0;
    if (HeightAngleSetVar == 1)
    	heightangle = ANG45 / 9;
    if (HeightAngleSetVar == 2)
    	heightangle = ANG45 / 3;
    if (HeightAngleSetVar == 3)
    	heightangle = ANG45 * 2 / 3;
    if (HeightAngleSetVar == 4)
    	heightangle = ANG45;
    if (HeightAngleSetVar == 5)
    	heightangle = -ANG45 / 9;
    
    if (IdealDistSetVar == 0)
    	idealdistance = 3000000;
    if (IdealDistSetVar == 1)
    	idealdistance = 5000000;
    if (IdealDistSetVar == 2)
    	idealdistance = 7000000;
    if (IdealDistSetVar == 3)
    	idealdistance = 10000000;
    if (IdealDistSetVar == 4)
    	idealdistance = 20000000;
    if (IdealDistSetVar == 5)
    	idealdistance = 30000000;
    
	
	
	dist = idealdistance * percentideal / 100;

	camloc = P_CamMax(player->mo, camangle, heightangle, dist);
	
	while (ccmode == 3 && camloc->health == 100)  // wall pop
	{
	percentideal -= 4;
	dist = idealdistance * percentideal / 100;
	camloc = P_CamMax(player->mo, camangle, heightangle, dist);
	}	
	
	if (!camloc->health)
    {
    // No line hit!
    player->real->x = player->mo->x + FixedMul(dist,finecosine[camangle >> ANGLETOFINESHIFT]);
	player->real->y = player->mo->y + FixedMul(dist,finesine[camangle >> ANGLETOFINESHIFT]);
	player->real->z = player->mo->z + player->viewheight + FixedMul(dist,finesine[heightangle >> ANGLETOFINESHIFT]);
    }
	else if(camloc->health == 100)
	{
	player->real->x = camloc->x;
    player->real->y = camloc->y;
    player->real->z = camloc->z;
    if (ccmode == 1)
    	{
		percentideal = 100;
    	ccmode = 2;
    	}
    }
    else if(camloc->health == 101)  // special for portals
	{
	player->real->x = player->mo->x + FixedMul(dist,finecosine[camangle >> ANGLETOFINESHIFT]);
	player->real->y = player->mo->y + FixedMul(dist,finesine[camangle >> ANGLETOFINESHIFT]);
	player->real->z = camloc->z;
    }
    
    if (abs(player->real->x - player->mo->x) && abs(player->real->y - player->mo->y))
		player->real->angle = R_PointToAngle2( player->real->x, player->real->y, player->mo->x, player->mo->y);
	else
    	player->real->angle = player->mo->angle;
    
    P_SetThingPosition( player->real );
    
    if (player->real->z < player->real->subsector->sector->floorheight /*+ 7 * FRACUNIT*/)
    	player->real->z = player->real->subsector->sector->floorheight + 14 * FRACUNIT;
    if (player->real->z > player->real->subsector->sector->ceilingheight /*- 7 * FRACUNIT*/)
    	player->real->z = player->real->subsector->sector->ceilingheight - 14 * FRACUNIT;
    }
}
