//PrjDOOM code module for g_* code modules
//
//This module contains:
//
//Sky-For-Every-Level
//In-Game Demos

static const char
rcsid[] = "$Id: g_prjdm.c,v 1.63 1999/1/18 06:59:50 Steve Exp $";

#include "doomstat.h"
#include "r_data.h"
#include "g_game.h"
#include "g_prjdm.h"
#include "r_sky.h"

#include "w_wad.h"
#include "m_misc.h"
#include "debug.h"

void G_SkySelect(void)
{
 //Steve 9/13/98 - Sky for every level crap, first, make the skyname var
 sprintf(skyname, "sky_%i",gamemap); 

 //Steve 9/13/98 - First, set it to 'original' sky, then overwrite as needed, first for
 // sky_def, then for sky_(lev#)

 if(R_CheckTextureNumForName( "sky_def" ) > 0){
  skytexture = R_TextureNumForName( "sky_def" ); 
 }

 if(R_CheckTextureNumForName( skyname ) > 0){
  skytexture = R_TextureNumForName( skyname );
 }
}


//In-game demos 

void G_DeferedIntDemo( char* name )
{
 plyrcpy = players[consoleplayer];  
 gameepisode2 = gameepisode;
 gamemap2 = gamemap+1;
 gameskill2 = gameskill;

 defdemoname = name;
 gameaction = ga_playdemo;
 intdemo = true;
}

void G_ResetState( void )
{
 players[consoleplayer]= plyrcpy;
 gamemap = gamemap2;
 gameepisode = gameepisode2;
 gameskill = gameskill2;
}

