//PrjDOOM code module for CD-Audio
//
//This module contains:
//
//CD-Audio

static const char
rcsid[] = "$Id: i_cdaudio.c,v 1.63 1999/1/18 06:59:50 Steve Exp $";

#include <bcd.h>


#include "doomstat.h"
#include "lprintf.h"
#include "i_cdaud.h"
#include "sounds.h"
#include "debug.h"
#include <allegro.h>

#define VOLSCALE 16 
//from i_sound.c

int I_ChooseCDMusic( int musicnum, int cdnext, int cdprev )
{
 switch(musicnum)
 {
  case mus_victor:
   tracknum = 16;
   break;
  case mus_dm2int:
   tracknum = 17;
   break;
  case mus_read_m:
   tracknum = 18;
   break;
  case mus_inter:
   tracknum = 19;
   break;
  case mus_evil:
   tracknum = 20;
   break;
  case mus_dm2ttl:
   tracknum = 21;
   break;
  case mus_intro:
   tracknum = 22;
   break;
  case mus_bunny:
   tracknum = 23;
   break;
  default:
   if(cdprev)
    i--;
   else
    i++;
   tracknum = i;
   break;
  }
 if( !(trackmap[tracknum] < tracks) )
  if( !(trackmap[tracknum] - 16 < tracks) )
   tracknum -= 16;
  else
   tracknum = deftrack;

 return trackmap[tracknum];
} 


void I_PlayCDMusic( int musicnum, int cdnext, int cdprev)
{

 int track = I_ChooseCDMusic(musicnum, cdnext, cdprev);

 WriteDebugFile( "Playing CD Track" );
 WriteIntDebugFile( track );

 WriteDebugFile( "TrackMap Says.." );
 WriteIntDebugFile( trackmap[tracknum] );

 WriteDebugFile( "Tracknum is.." );
 WriteIntDebugFile( tracknum );
 WriteDebugFile( "\n" );

 stop_midi();
 if (bcd_audio_busy()!=0)
  bcd_stop();

 bcd_play_track(track);

}

void I_PauseCDMusic( void )
{
 bcd_pause();
}

void I_ResumeCDMusic( void )
{
 bcd_resume();
} 

void I_StopCDMusic( void ) 
{
  bcd_stop();
}


//add stuff here - steve
void I_SetCDVolume( int volume )
{
  
 int a;

 // Internal state variable.
 snd_CDVolume = volume;
 // Now set volume on output device.

 //jff 01/17/98 - add VOLSCALE-1 to get most out of volume
 a = bcd_set_volume(snd_CDVolume*VOLSCALE+VOLSCALE-1);   // jff 1/18/98

}

void I_InitCDAudio( void )
{

 lprintf(LO_INFO,"I_CDAudio: ");
 bcd_open();
 tracks = bcd_get_audio_info();
 lprintf(LO_INFO,"CD-Audio Ready\n");
 deftrack = 0;
 i=-1;

}