#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <conio.h>
#include "doomstat.h"
#include "w_wad.h"
#include "mapinfo.h"
#include "z_zone.h"
#include "debug.h"

void G_LoadMapInfoLump( void )
{

 int n;
 char *mapinfolump;

 mapinfolump = (char *)W_CacheLumpName("MAPINFO", PU_STATIC);
 
 WriteDebugFile( "Contents" );

 for(n=0;n<25;n++)
  WriteDebugFile( *mapinfolump++ );

}

void G_InitCommands( void )
{
 sprintf(commands[0].name, "StartLoc =");
 commands[0].inputype = 2;

 sprintf(commands[1].name, "GoalLoc =");
 commands[1].inputype = 2;

 sprintf(commands[2].name, "TimeLimit =");
 commands[2].inputype = 1;

 sprintf(commands[3].name, "Slow =");
 commands[3].inputype = 1;

 sprintf(commands[4].name, "Debug =");
 commands[4].inputype = 1;
 
//General Commands

 //printf( "." );

 sprintf(commands[5].name, "Pause");
 commands[5].inputype = 1;

 sprintf(commands[6].name, "LoadMap");
 commands[6].inputype = 1;

 sprintf(commands[7].name, "Text =");
 commands[7].inputype = 4;

 sprintf(commands[8].name, "GameLoop");
 commands[8].inputype = 5;

 sprintf(commands[9].name, "Redraw");
 commands[9].inputype = 5;

//BotState

 //printf( "." );

 sprintf(commands[10].name, "BotLoc =");
 commands[10].inputype = 2;

 sprintf(commands[11].name, "Traits =");
 commands[11].inputype = 3;

 sprintf(commands[12].name, "AINum =");
 commands[12].inputype = 1;

 sprintf(commands[13].name, "Goal =");
 commands[13].inputype = 1;

 sprintf(commands[14].name, "Thrifty =");
 commands[14].inputype = 1;

 sprintf(commands[15].name, "Updown =" );
 commands[15].inputype = 1;

 sprintf(commands[16].name, "Annoyed =");
 commands[16].inputype = 1;

 sprintf(commands[17].name, "UpFailed =");
 commands[17].inputype = 1;

 sprintf(commands[18].name, "DownFailed =");
 commands[18].inputype = 1;

 sprintf(commands[19].name, "Action" );
 commands[19].inputype = 4;
 
//Oops, newer commands

 //printf( "." );

 sprintf(commands[20].name, "ClearScreen" );
 commands[20].inputype = 5;

 sprintf(commands[21].name, "NextLoc =" );
 commands[21].inputype = 2;

 //printf( "\n" );

}

void G_LoadScript( void )
{

 int mapinfocnt, linecnt, i;

 scriptcmd_t* command;

 mapinfocnt = -1; 

 linecnt = -1;

 G_ClearLine();
 
 do
 {
  if(mapinfolump[mapinfocnt++] == ';') //Endline
  {
   G_ClearLine();
   continue;
  }
  
  if(mapinfolump[mapinfocnt] == '') //End of file
   break;  

  line[linecnt++] = mapinfolump[mapinfocnt++];

  WriteDebugFile( "Character" );
  WriteIntDebugFile( linecnt );
  WriteDebugFile( "Line" );
  WriteDebugFile( line );

  for(i=0;i<COMMANDS;i++)
   if(strcmp(line, commands[i].name) == 0)
   {
    WriteDebugFile( "Found" );
    WriteDebugFile( line );

    sprintf(script[scriptnum].name, commands[i].name);

    //command = &script[scriptnum];
    //G_LoadValues(command);
    //G_AssignValues(command);
    G_NewLine();
    scriptnum++;
  
    WriteDebugFile( "Done with found" );
  
    break;

   }
 
 WriteDebugFile( "\n" );

 }while(mapinfolump[mapinfocnt] != ''); //Don't really know this

}

void G_LoadValues( scriptcmd_t *command)
{
 int i = -1;

 datacnt = 0;

 G_ClearData();

 do
 {
  if(mapinfolump[mapinfocnt++] == ',')
  {
   datacnt++;
   i = -1;
   continue;
  }      

  if(mapinfolump[mapinfocnt] == ';' )
   break;
  
  i++;
 
  data[datacnt][i] = mapinfolump[mapinfocnt]; //Add the current character (while not a \n or a ,) to the raw value

  WriteDebugFile( "Current Data" );
  WriteDebugFile( data[datacnt]);
  WriteDebugFile( "i" );
  WriteIntDebugFile( i );
  WriteDebugFile( "Command Counter" );
  WriteIntDebugFile( datacnt );

 }while(mapinfolump[mapinfocnt] != '\n'); //I really don't need that while, but it's required

 WriteDebugFile( "Done with Loading Values" );
}


void G_AssignValues( scriptcmd_t *command )
{

 int i,p;

 for(i = 0; i<COMMANDS;i++)
 {
  if(strcmp(command->name, commands[i].name) == 0)
  { 
/*
   switch(commands[i].inputype)
   {

    case 1: //Simple Value
     command->value = atoi(data[0]);
     break;

    case 2: //A loc
     command->loc.x = atoi(data[0]);
     command->loc.y = atoi(data[1]);
     break;

    case 3: //AI Traits
     command->ai.thriftyness = atoi(data[0]);
     command->ai.updown = atoi(data[1]);
     command->ai.annoyance = atoi(data[2]);
     command->ai.resolutness = atoi(data[3]);
     command->ai.lookahead = atoi(data[4]);
     break;      
           
    case 4:
     for(p=0;p<LINES;p++)
     {
      WriteDebugFile( "p" );
      WriteIntDebugFile( p );
      WriteDebugFile( "Raw Data" );
      WriteDebugFile( data[p] );
      sprintf(command->text[p], data[p]);
      WriteDebugFile( "What it came up with" );
      WriteDebugFile(command->text[p]);
     }
     break;
   }       
*/
 }

  
  break; 

 }
}


void G_ExecScript( void )
{
 int p,q,r;
 
 WriteDebugFile( "Start G_ExecScript" );

 //clrscr();
 
 for(p=0;p<SCRIPTSIZE;p++)
 {
  if(script[p].name == '\0') //If it's not there...
   continue;
  for(q=0;q<COMMANDS;q++)
  {
   if(strcmp(script[p].name, commands[q].name) == 0)
   {

    WriteDebugFile( "Certified Command" );
    WriteDebugFile( commands[q].name ); 
 
/*
    switch(q)
    {
     case 0: 
      defaults.startloc = script[p].loc;
      break;
     case 1:
      goalloc = script[p].loc;
      break;
     case 2:
      defaults.maxtime = script[p].value;
      break;
     case 3:
      defaults.wait = script[p].value;
      break;
     case 4:
      defaults.debug = script[p].value;
      break;
     case 5:
      sleep(script[p].value);
      break;
     case 6:
      I_LoadMap(script[p].value);
      break;    
     case 7:
      WriteDebugFile( "Copying Text" );
      for(r=0;r<LINES;r++)
      {
       sprintf(text[r], script[p].text[r]);
       WriteDebugFile( "New text" );
       WriteDebugFile( text[r] );
       WriteDebugFile( "script text" );
       WriteDebugFile( script[p].text[r] );
      }
      break;
     case 8:
      G_GameLoop();
      break;
     case 9:
      D_DrawMap();
      break;
     case 10:
      player.loc = script[p].loc;
      break;
     case 11:
      player.ai = script[p].ai;
      break;
     case 12:
      player.ai.number = script[p].value;
      break;
     case 13:
      player.goal = script[p].value;
      break;
     case 14:
      player.state.thrifty = script[p].value;
      break;
     case 15:
      player.state.updown = script[p].value;
      break;
     case 16:
      player.state.annoyed = script[p].value;
      break;
     case 17:
      player.state.upfailed = script[p].value;
      break;    
     case 18:
      player.state.downfailed = script[p].value;
      break;
     case 19:
      sprintf(player.state.action, script[p].text[0]);
      break;
     case 20:
      clrscr();
      break;
     case 21:
      nextloc = script[p].loc; 
      break;
    }
*/

   }
  }
 }
}

void G_NewLine( void ) //Prepares all variables and clears the next file line
{
 linecnt = 0;
 G_ClearLine();
}

void G_ClearLine( void )
{
 int q;

  for(q=0;q<80;q++)
  line[q] = '\0';
}

void G_ClearData( void )
{
 int p,q;
 for(p=0;p<6;p++)
  for(q=0;q<80;q++)
   data[p][q] = '\0';
} 


