#ifndef __MAPINFO__
#define __MAPINFO__

#define MAPINFOSIZE 500
#define COMMANDS 7
#define LINES 5
#define SCRIPTSIZE 25

typedef struct
{
 char name[10];
} ai_t;

typedef struct
{
 char name[10];
} loc_t;

typedef struct
{
 boolean bunny;
 boolean castcall;
 boolean textscreen;
 char text[450];
 char texture[20];
 char music[20];
 boolean intdemo;
 char demoname[20];
 boolean useme;
} intinfo_t;

typedef struct
{
 boolean useme;
 char skytex[20];
 int mapexit;
 char mapname;
 intinfo_t mapintermission;
} mapinfo_t;

typedef struct
{
 char name[80];
 int inputype;
 char raw[10][80];
 int counter;
 int value;
 char text[10][80]; //These will change based upon the requirements of the text box
 loc_t loc;
 ai_t ai;

} scriptcmd_t;

typedef struct
{
 char name[80];
 int inputype;
} cmdinfo_t;

scriptcmd_t hi;

cmdinfo_t commands[COMMANDS];

int linecnt, datacnt, mapinfocnt, scriptnum;

char * mapinfolump;

char line[80], data[LINES][80];

scriptcmd_t script[SCRIPTSIZE];

void G_InitCommands( void );
void G_LoadScript( void );
void G_LoadValues( scriptcmd_t *command);
void G_AssignValues( scriptcmd_t *command );
void G_ClearArray( void );
void G_NewLine( void );
void G_ExecScript( void );
void G_ClearData( void );
void G_ClearLine( void );
void G_LoadMapInfoLump( void );

#endif